# The versions of this image and the docker service defined in the `services` section must be kept in sync! 
image: docker:23.0.4

. build_job_template: &build_job
  stage: build
  script:
    - jq
    - if [ -z ${JDK_VERSION+x} ]; then echo "JDK_VERSION environment variable must be set" >&2 ; exit 1; fi
    - ./build.sh ${JDK_VERSION}
    - source tag-${JDK_VERSION}-jdk.env
    - docker push ${REF_COMMIT_TAG}
  artifacts:
    reports:
      dotenv: tag-${JDK_VERSION}-jdk.env

. newer_tag_job_template: &tag_job
  stage: tag
  script:
    - if [ -z ${BASE_IMAGE_TAG+x} ]; then echo "BASE_IMAGE_TAG environment variable must be set" >&2 ; exit 1; fi
    - if [ -z ${REF_TAG+x} ]; then echo "REF_TAG environment variable must be set" >&2 ; exit 1; fi
    - if [ -z ${REF_COMMIT_TAG+x} ]; then echo "REF_COMMIT_TAG environment variable must be set" >&2 ; exit 1; fi
    - ./tag.sh "${BASE_IMAGE_TAG}" "${REF_TAG}" "${REF_COMMIT_TAG}" "${CI_COMMIT_TAG}"

. ref_tag_job_template: &ref_tag_job
  stage: tag
  script:
    - if [ -z ${BASE_IMAGE_TAG+x} ]; then echo "BASE_IMAGE_TAG environment variable must be set" >&2 ; exit 1; fi
    - if [ -z ${REF_TAG+x} ]; then echo "REF_TAG environment variable must be set" >&2 ; exit 1; fi
    - if [ -z ${REF_COMMIT_TAG+x} ]; then echo "REF_COMMIT_TAG environment variable must be set" >&2 ; exit 1; fi
    - docker pull ${REF_COMMIT_TAG} 
    - docker tag ${REF_COMMIT_TAG} ${REF_TAG}:latest
    - docker push ${REF_TAG}:latest

. stable_orc_rc_tag_job_template: &stable_or_rc_tag_job
  stage: tag
  rules:
    - if : $CI_COMMIT_TAG =~ /^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-rc\.[1-9]\d*)*$/
  script:
    - if [ -z ${BASE_IMAGE_TAG+x} ]; then echo "BASE_IMAGE_TAG environment variable must be set" >&2 ; exit 1; fi
    - if [ -z ${REF_COMMIT_TAG+x} ]; then echo "REF_COMMIT_TAG environment variable must be set" >&2 ; exit 1; fi
    - docker pull ${REF_COMMIT_TAG} 
    - docker tag ${REF_COMMIT_TAG} ${BASE_IMAGE_TAG}:${CI_COMMIT_TAG}
    - docker push ${BASE_IMAGE_TAG}:${CI_COMMIT_TAG}
    - ./tag-test.sh

stages:
  - build
  - test
  - tag

variables:
  DOCKER_TLS_CERTDIR: "/certs"

services:
  - docker:23.0.4-dind

before_script:
  # Ensure that we're logged into the registry before performing any opertions
  - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}

build:8-jdk:
  variables:
    JDK_VERSION: "8"
  <<: *build_job

build:17-jdk:
  variables:
    JDK_VERSION: "17"  
  <<: *build_job

. tag:ref:8-jdk:
  <<: *ref_tag_job
  needs:
    - job: build:8-jdk
      artifacts: true

. tag:ref:17-jdk:
  <<: *ref_tag_job
  needs:
    - job: build:17-jdk
      artifacts: true

. tag:stable_or_rc:8-jdk:
  <<: *stable_or_rc_tag_job
  needs:
    - job: build:8-jdk
      artifacts: true      

. tag:stable_or_rc:17-jdk:
  <<: *stable_or_rc_tag_job
  needs:
    - job: build:17-jdk
      artifacts: true

tag:8-jdk:
  <<: *tag_job
  needs:
    - job: build:8-jdk
      artifacts: true

tag:17-jdk:
  <<: *tag_job
  needs:
    - job: build:17-jdk
      artifacts: true
